aboutsummaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorRoland McGrath <roland@gnu.org>2003-02-25 23:45:16 +0000
committerRoland McGrath <roland@gnu.org>2003-02-25 23:45:16 +0000
commit1d02f71fe4046c1cd17ff6b6687a89932797cb3b (patch)
treed73f941e908994fa60b5932d98510aaf5cb15c2f
parentfec417190420a427bec2340853f42051da251b65 (diff)
downloadglibc-1d02f71fe4046c1cd17ff6b6687a89932797cb3b.tar.xz
glibc-1d02f71fe4046c1cd17ff6b6687a89932797cb3b.zip
linuxthreads/ChangeLog
2003-02-25 Roland McGrath <roland@redhat.com> * sysdeps/powerpc/powerpc64/dl-machine.h: Support new TLS relocs. * sysdeps/powerpc/powerpc64/dl-tls.h: New file.
-rw-r--r--ChangeLog5
-rw-r--r--configure.in4
-rw-r--r--dlfcn/Makefile10
-rw-r--r--linuxthreads/ChangeLog5
-rw-r--r--linuxthreads/sysdeps/i386/i686/pt-machine.h3
-rw-r--r--linuxthreads/sysdeps/i386/pt-machine.h3
-rw-r--r--linuxthreads/sysdeps/i386/tls.h2
-rw-r--r--linuxthreads/sysdeps/powerpc/powerpc64/tls.h134
-rw-r--r--linuxthreads/sysdeps/unix/sysv/linux/powerpc/powerpc64/vfork.S8
-rw-r--r--mach/Versions3
-rw-r--r--sysdeps/mach/alpha/machine-lock.h10
-rw-r--r--sysdeps/mach/configure49
-rw-r--r--sysdeps/mach/hurd/alpha/tls.h53
-rwxr-xr-xsysdeps/mach/hurd/configure10
-rw-r--r--sysdeps/powerpc/powerpc64/dl-machine.h164
-rw-r--r--sysdeps/powerpc/powerpc64/dl-tls.h40
-rw-r--r--sysdeps/unix/sysv/linux/configure12
-rw-r--r--sysdeps/unix/sysv/linux/dl-librecon.h7
18 files changed, 474 insertions, 48 deletions
diff --git a/ChangeLog b/ChangeLog
index c1d3baab55..b4aca0aedf 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,6 @@
+2003-02-25 Roland McGrath <roland@redhat.com>
+
+
2003-02-25 Steven Munroe <sjmunroe@us.ibm.com>
* elf/elf.h: Add new R_PPC64_* relocs for TLS.
@@ -5,6 +8,8 @@
(TLS_LE, TLS_IE, TLS_LD, TLS_GD): Define.
* sysdeps/powerpc/powerpc64/elf/configure.in: New file.
* sysdeps/powerpc/powerpc64/elf/configure: New file (generated).
+ * sysdeps/powerpc/powerpc64/dl-machine.h: Support new TLS relocs.
+ * sysdeps/powerpc/powerpc64/dl-tls.h: New file.
* sysdeps/powerpc/elf/libc-start.c (__libc_start_main):
Do DL_SYSDEP_OSCHECK here, matching 2002-12-01 change to generic file.
diff --git a/configure.in b/configure.in
index f7d8471cfe..fb801a7738 100644
--- a/configure.in
+++ b/configure.in
@@ -1111,7 +1111,7 @@ EOF
int bar __attribute__ ((visibility ("protected"))) = 1;
EOF
libc_cv_visibility_attribute=no
- if ${CC-cc} -Werror -S conftest.c -o conftest.s >/dev/null 2>&1; then
+ if AC_TRY_COMMAND[${CC-cc} -Werror -S conftest.c -o conftest.s 1>&AS_MESSAGE_LOG_FD 2>&AS_MESSAGE_LOG_FD]; then
if grep '\.hidden.*foo' conftest.s >/dev/null; then
if grep '\.protected.*bar' conftest.s >/dev/null; then
libc_cv_visibility_attribute=yes
@@ -1134,7 +1134,7 @@ EOF
int bar (int x) { return x; }
EOF
libc_cv_broken_visibility_attribute=yes
- if ${CC-cc} -Werror -S conftest.c -o conftest.s >/dev/null 2>&1; then
+ if ${CC-cc} -Werror -S conftest.c -o conftest.s >&AS_MESSAGE_LOG_FD 2>&AS_MESSAGE_LOG_FD; then
changequote(,)dnl
if grep '\.hidden[ _]foo' conftest.s >/dev/null; then
changequote([,])dnl
diff --git a/dlfcn/Makefile b/dlfcn/Makefile
index 40eb7888cc..9cff10baba 100644
--- a/dlfcn/Makefile
+++ b/dlfcn/Makefile
@@ -37,7 +37,7 @@ libdl-shared-only-routines += eval
ifeq (yes,$(build-shared))
tests = glrefmain failtest tst-dladdr default errmsg1 tstcxaatexit \
- bug-dlopen1 bug-dlsym1
+ bug-dlopen1 bug-dlsym1 bug-dlopen-leak
ifeq (yes,$(have-protected))
tests += tstatexit
endif
@@ -99,6 +99,14 @@ $(objpfx)modstatic.so: $(common-objpfx)libc.so $(common-objpfx)libc_nonshared.a
$(objpfx)bug-dlopen1: $(libdl)
+$(objpfx)bug-dlopen-leak: $(libdl)
+bug-dlopen-leak-ENV = MALLOC_TRACE=$(objpfx)bug-dlopen-leak.mtrace
+$(objpfx)mtrace-bug-dlopen-leak: $(objpfx)bug-dlopen-leak.out
+ $(common-objpfx)malloc/mtrace $(objpfx)bug-dlopen-leak.mtrace > $@
+ifneq (no,$(PERL))
+tests: $(objpfx)mtrace-bug-dlopen-leak
+endif
+
$(objpfx)bug-dlsym1: $(libdl) $(objpfx)bug-dlsym1-lib2.so
$(objpfx)bug-dlsym1.out: $(objpfx)bug-dlsym1-lib1.so \
$(objpfx)bug-dlsym1-lib2.so
diff --git a/linuxthreads/ChangeLog b/linuxthreads/ChangeLog
index adfaaa8f0e..de105a6649 100644
--- a/linuxthreads/ChangeLog
+++ b/linuxthreads/ChangeLog
@@ -1,3 +1,8 @@
+2003-01-31 Steven Munroe <sjmunroe@us.ibm.com>
+
+ * sysdeps/unix/sysv/linux/powerpc/powerpc64/vfork.S [SHARED]:
+ Conditionalize .toc section magic on this.
+
2003-02-21 Roland McGrath <roland@redhat.com>
* cancel.c (__pthread_perform_cleanup): Call __libc_thread_freeres
diff --git a/linuxthreads/sysdeps/i386/i686/pt-machine.h b/linuxthreads/sysdeps/i386/i686/pt-machine.h
index 3c28118f2e..2368c29098 100644
--- a/linuxthreads/sysdeps/i386/i686/pt-machine.h
+++ b/linuxthreads/sysdeps/i386/i686/pt-machine.h
@@ -33,7 +33,8 @@ extern int __compare_and_swap (long int *p, long int oldval, long int newval);
/* Get some notion of the current stack. Need not be exactly the top
of the stack, just something somewhere in the current frame. */
-#define CURRENT_STACK_FRAME __builtin_frame_address (0)
+#define CURRENT_STACK_FRAME __stack_pointer_register__
+register char *__stack_pointer_register__ __asm__ ("%esp");
/* Spinlock implementation; required. */
diff --git a/linuxthreads/sysdeps/i386/pt-machine.h b/linuxthreads/sysdeps/i386/pt-machine.h
index 79c69b549a..465ab9f919 100644
--- a/linuxthreads/sysdeps/i386/pt-machine.h
+++ b/linuxthreads/sysdeps/i386/pt-machine.h
@@ -32,7 +32,8 @@ extern int __compare_and_swap (long int *p, long int oldval, long int newval);
/* Get some notion of the current stack. Need not be exactly the top
of the stack, just something somewhere in the current frame. */
-#define CURRENT_STACK_FRAME __builtin_frame_address (0)
+#define CURRENT_STACK_FRAME __stack_pointer_register__
+register char *__stack_pointer_register__ __asm__ ("%esp");
/* Spinlock implementation; required. */
diff --git a/linuxthreads/sysdeps/i386/tls.h b/linuxthreads/sysdeps/i386/tls.h
index 118c9c02d1..db68e1c21c 100644
--- a/linuxthreads/sysdeps/i386/tls.h
+++ b/linuxthreads/sysdeps/i386/tls.h
@@ -58,7 +58,7 @@ typedef struct
We need USE_TLS to be consistently defined, for ldsodefs.h conditionals.
But some of the code below can cause problems in building libpthread
- (e.g. useldt.h will defined FLOATING_STACKS when it shouldn't). */
+ (e.g. useldt.h will define FLOATING_STACKS when it shouldn't). */
#if defined HAVE_TLS_SUPPORT \
&& (defined FLOATING_STACKS || !defined IS_IN_libpthread)
diff --git a/linuxthreads/sysdeps/powerpc/powerpc64/tls.h b/linuxthreads/sysdeps/powerpc/powerpc64/tls.h
new file mode 100644
index 0000000000..fefb452cc2
--- /dev/null
+++ b/linuxthreads/sysdeps/powerpc/powerpc64/tls.h
@@ -0,0 +1,134 @@
+/* Definitions for thread-local data handling. linuxthreads/PowerPC64 version.
+ Copyright (C) 2003 Free Software Foundation, Inc.
+ This file is part of the GNU C Library.
+
+ The GNU C Library is free software; you can redistribute it and/or
+ modify it under the terms of the GNU Lesser General Public
+ License as published by the Free Software Foundation; either
+ version 2.1 of the License, or (at your option) any later version.
+
+ The GNU C Library is distributed in the hope that it will be useful,
+ but WITHOUT ANY WARRANTY; without even the implied warranty of
+ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
+ Lesser General Public License for more details.
+
+ You should have received a copy of the GNU Lesser General Public
+ License along with the GNU C Library; if not, write to the Free
+ Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
+ 02111-1307 USA. */
+
+#ifndef _TLS_H
+#define _TLS_H
+
+#ifndef __ASSEMBLER__
+
+# include <pt-machine.h>
+# include <stddef.h>
+
+/* Type for the dtv. */
+typedef union dtv
+{
+ size_t counter;
+ void *pointer;
+} dtv_t;
+
+
+typedef struct
+{
+ dtv_t *dtv;
+
+ /* Reserved for the thread implementation. Unused in LinuxThreads. */
+ void *private;
+} tcbhead_t;
+#endif
+
+
+#ifdef HAVE_TLS_SUPPORT
+
+/* Signal that TLS support is available. */
+# define USE_TLS 1
+
+# ifndef __ASSEMBLER__
+/* Get system call information. */
+# include <sysdep.h>
+
+/* This is the size of the initial TCB. */
+# define TLS_INIT_TCB_SIZE sizeof (tcbhead_t)
+
+/* Alignment requirements for the initial TCB. */
+# define TLS_INIT_TCB_ALIGN __alignof__ (tcbhead_t)
+
+/* This is the size of the TCB. */
+# define TLS_TCB_SIZE sizeof (tcbhead_t)
+
+/* Alignment requirements for the TCB. */
+# define TLS_TCB_ALIGN __alignof__ (tcbhead_t)
+
+/* This is the size we need before TCB. */
+# define TLS_PRE_TCB_SIZE sizeof (struct _pthread_descr_struct)
+
+/* the following assumes that TP (R13) is points to the end of the tcb
+ + 0x7000 (per the ABI). This implies that tcb address is
+ R13-(TLS_TCB_SIZE + 0x7000). As we define TLS_DTV_AT_TP we can
+ assume that the pthread_descr is allocate immediately ahead of the
+ tcb. This implies that the pthread_descr address is
+ R13-(TLS_PRE_TCB_SIZE + TLS_TCB_SIZE + 0x7000). */
+# define TLS_TCB_OFFSET 0x7000
+
+/* The DTV is allocated at the TP; the TCB is placed elsewhere. */
+/* This is not really true for powerpc64. We are following alpha
+ where the DTV pointer is first doubleword in the TCB. */
+# define TLS_DTV_AT_TP 1
+
+/* Install the dtv pointer. The pointer passed is to the element with
+ index -1 which contain the length. */
+# define INSTALL_DTV(TCBP, DTVP) \
+ (((tcbhead_t *) (TCBP))->dtv = (DTVP) + 1)
+
+/* Install new dtv for current thread. */
+# define INSTALL_NEW_DTV(DTV) (THREAD_DTV() = (DTV))
+
+/* Return dtv of given thread descriptor. */
+# define GET_DTV(TCBP) (((tcbhead_t *) (TCBP))->dtv)
+
+/* Code to initially initialize the thread pointer. This might need
+ special attention since 'errno' is not yet available and if the
+ operation can cause a failure 'errno' must not be touched. */
+# define TLS_INIT_TP(TCBP, SECONDCALL) \
+ (__thread_self = (uintptr_t) (TCBP) + TLS_TCB_OFFSET + TLS_TCB_SIZE, 0)
+
+/* Return the address of the dtv for the current thread. */
+# define THREAD_DTV() \
+ (((tcbhead_t *) (__thread_register - (TLS_TCB_OFFSET + TLS_TCB_SIZE)))->dtv)
+
+/* Return the thread descriptor for the current thread. */
+# undef THREAD_SELF
+# define THREAD_SELF \
+ ((pthread_descr) (__thread_register \
+ - (TLS_TCB_OFFSET + TLS_TCB_SIZE + TLS_PRE_TCB_SIZE)))
+
+# undef INIT_THREAD_SELF
+# define INIT_THREAD_SELF(DESCR, NR) \
+ (__thread_self = (pthread_descr) (((char *)(DESCR)) \
+ + (TLS_TCB_OFFSET + TLS_TCB_SIZE + TLS_PRE_TCB_SIZE)))
+
+/* Get the thread descriptor definition. */
+# include <linuxthreads/descr.h>
+
+/* Generic bits of LinuxThreads may call these macros with
+ DESCR set to NULL. We are expected to be able to reference
+ the "current" value. */
+
+#define THREAD_GETMEM(descr, member) \
+ ((void) sizeof (descr), THREAD_SELF->member)
+#define THREAD_GETMEM_NC(descr, member) \
+ ((void) sizeof (descr), THREAD_SELF->member)
+#define THREAD_SETMEM(descr, member, value) \
+ ((void) sizeof (descr), THREAD_SELF->member = (value))
+#define THREAD_SETMEM_NC(descr, member, value) \
+ ((void) sizeof (descr), THREAD_SELF->member = (value))
+
+# endif /* HAVE_TLS_SUPPORT */
+#endif /* __ASSEMBLER__ */
+
+#endif /* tls.h */
diff --git a/linuxthreads/sysdeps/unix/sysv/linux/powerpc/powerpc64/vfork.S b/linuxthreads/sysdeps/unix/sysv/linux/powerpc/powerpc64/vfork.S
index 0229a9a75c..b408e31b7b 100644
--- a/linuxthreads/sysdeps/unix/sysv/linux/powerpc/powerpc64/vfork.S
+++ b/linuxthreads/sysdeps/unix/sysv/linux/powerpc/powerpc64/vfork.S
@@ -25,17 +25,19 @@
The calling process is suspended until the new process exits or is
replaced by a call to `execve'. Return -1 for errors, 0 to the new process,
and the process ID of the new process to the old process. */
-
+
+#ifdef SHARED
.section ".toc","aw"
.LC0:
.tc __libc_pthread_functions[TC],__libc_pthread_functions
.section ".text"
.align 2
+#endif
ENTRY (__vfork)
#ifdef __NR_vfork
-
+
# ifdef SHARED
ld 10,.LC0@toc(2)
ld 10,0(10)
@@ -53,7 +55,7 @@ ENTRY (__vfork)
# endif
DO_CALL (SYS_ify (vfork));
-
+
# ifdef __ASSUME_VFORK_SYSCALL
PSEUDO_RET
# else
diff --git a/mach/Versions b/mach/Versions
index 18ec511d91..d2b8402aa6 100644
--- a/mach/Versions
+++ b/mach/Versions
@@ -70,6 +70,9 @@ libc {
# This was always there, but not exported as it should have been.
mig_strncpy;
}
+ GLIBC_2.3 {
+ NDR_record;
+ }
%if !SHLIB_COMPAT (libc, GLIBC_2_0, GLIBC_2_2)
HURD_CTHREADS_0.3 {
diff --git a/sysdeps/mach/alpha/machine-lock.h b/sysdeps/mach/alpha/machine-lock.h
index 80f8750c87..363c29e56f 100644
--- a/sysdeps/mach/alpha/machine-lock.h
+++ b/sysdeps/mach/alpha/machine-lock.h
@@ -1,5 +1,5 @@
/* Machine-specific definition for spin locks. Alpha version.
- Copyright (C) 1994, 1997 Free Software Foundation, Inc.
+ Copyright (C) 1994,97,2002 Free Software Foundation, Inc.
This file is part of the GNU C Library.
The GNU C Library is free software; you can redistribute it and/or
@@ -38,8 +38,8 @@ typedef __volatile long int __spin_lock_t;
_EXTERN_INLINE void
__spin_unlock (__spin_lock_t *__lock)
{
- __asm__ __volatile__ ("mb; stq $31, %0; mb"
- : "=m" (__lock));
+ __asm__ __volatile__ ("mb");
+ *__lock = 0;
}
/* Try to lock LOCK; return nonzero if we locked it, zero if another has. */
@@ -47,6 +47,9 @@ __spin_unlock (__spin_lock_t *__lock)
_EXTERN_INLINE int
__spin_try_lock (register __spin_lock_t *__lock)
{
+#if 1
+ return 1;
+#else
register long int __rtn, __tmp;
do
@@ -66,6 +69,7 @@ __spin_try_lock (register __spin_lock_t *__lock)
} while (! __rtn);
/* RTN is now nonzero; we have the lock. */
return __rtn;
+#endif
}
/* Return nonzero if LOCK is locked. */
diff --git a/sysdeps/mach/configure b/sysdeps/mach/configure
index 597a0a5b1b..6fd414845f 100644
--- a/sysdeps/mach/configure
+++ b/sysdeps/mach/configure
@@ -102,7 +102,7 @@ _ACEOF
if { (eval echo "$as_me:$LINENO: \"$ac_cpp conftest.$ac_ext\"") >&5
(eval $ac_cpp conftest.$ac_ext) 2>conftest.er1
ac_status=$?
- grep -v '^ *+' conftest.er1 >conftest.err
+ egrep -v '^ *\+' conftest.er1 >conftest.err
rm -f conftest.er1
cat conftest.err >&5
echo "$as_me:$LINENO: \$? = $ac_status" >&5
@@ -148,7 +148,7 @@ _ACEOF
if { (eval echo "$as_me:$LINENO: \"$ac_cpp conftest.$ac_ext\"") >&5
(eval $ac_cpp conftest.$ac_ext) 2>conftest.er1
ac_status=$?
- grep -v '^ *+' conftest.er1 >conftest.err
+ egrep -v '^ *\+' conftest.er1 >conftest.err
rm -f conftest.er1
cat conftest.err >&5
echo "$as_me:$LINENO: \$? = $ac_status" >&5
@@ -193,6 +193,12 @@ else
#line $LINENO "configure"
#include "confdefs.h"
#include <mach/mach_types.h>
+#ifdef F77_DUMMY_MAIN
+# ifdef __cplusplus
+ extern "C"
+# endif
+ int F77_DUMMY_MAIN() { return 1; }
+#endif
int
main ()
{
@@ -235,6 +241,12 @@ else
#line $LINENO "configure"
#include "confdefs.h"
#include <mach/mach_types.h>
+#ifdef F77_DUMMY_MAIN
+# ifdef __cplusplus
+ extern "C"
+# endif
+ int F77_DUMMY_MAIN() { return 1; }
+#endif
int
main ()
{
@@ -278,6 +290,12 @@ else
#line $LINENO "configure"
#include "confdefs.h"
#include <mach/task_info.h>
+#ifdef F77_DUMMY_MAIN
+# ifdef __cplusplus
+ extern "C"
+# endif
+ int F77_DUMMY_MAIN() { return 1; }
+#endif
int
main ()
{
@@ -336,7 +354,7 @@ _ACEOF
if { (eval echo "$as_me:$LINENO: \"$ac_cpp conftest.$ac_ext\"") >&5
(eval $ac_cpp conftest.$ac_ext) 2>conftest.er1
ac_status=$?
- grep -v '^ *+' conftest.er1 >conftest.err
+ egrep -v '^ *\+' conftest.er1 >conftest.err
rm -f conftest.er1
cat conftest.err >&5
echo "$as_me:$LINENO: \$? = $ac_status" >&5
@@ -372,21 +390,6 @@ echo "$as_me: error: what manner of Mach is this?" >&2;}
{ (exit 1); exit 1; }; }
fi
-echo "$as_me:$LINENO: checking for egrep" >&5
-echo $ECHO_N "checking for egrep... $ECHO_C" >&6
-if test "${ac_cv_prog_egrep+set}" = set; then
- echo $ECHO_N "(cached) $ECHO_C" >&6
-else
- if echo a | (grep -E '(a|b)') >/dev/null 2>&1
- then ac_cv_prog_egrep='grep -E'
- else ac_cv_prog_egrep='egrep'
- fi
-fi
-echo "$as_me:$LINENO: result: $ac_cv_prog_egrep" >&5
-echo "${ECHO_T}$ac_cv_prog_egrep" >&6
- EGREP=$ac_cv_prog_egrep
-
-
echo "$as_me:$LINENO: checking for host_page_size in mach_host.defs" >&5
echo $ECHO_N "checking for host_page_size in mach_host.defs... $ECHO_C" >&6
if test "${libc_cv_mach_host_page_size+set}" = set; then
@@ -399,7 +402,7 @@ else
_ACEOF
if (eval "$ac_cpp conftest.$ac_ext") 2>&5 |
- $EGREP "host_page_size" >/dev/null 2>&1; then
+ egrep "host_page_size" >/dev/null 2>&1; then
libc_cv_mach_host_page_size=yes
else
libc_cv_mach_host_page_size=no
@@ -429,7 +432,7 @@ _ACEOF
if { (eval echo "$as_me:$LINENO: \"$ac_cpp conftest.$ac_ext\"") >&5
(eval $ac_cpp conftest.$ac_ext) 2>conftest.er1
ac_status=$?
- grep -v '^ *+' conftest.er1 >conftest.err
+ egrep -v '^ *\+' conftest.er1 >conftest.err
rm -f conftest.er1
cat conftest.err >&5
echo "$as_me:$LINENO: \$? = $ac_status" >&5
@@ -469,7 +472,7 @@ _ACEOF
if { (eval echo "$as_me:$LINENO: \"$ac_cpp conftest.$ac_ext\"") >&5
(eval $ac_cpp conftest.$ac_ext) 2>conftest.er1
ac_status=$?
- grep -v '^ *+' conftest.er1 >conftest.err
+ egrep -v '^ *\+' conftest.er1 >conftest.err
rm -f conftest.er1
cat conftest.err >&5
echo "$as_me:$LINENO: \$? = $ac_status" >&5
@@ -514,7 +517,7 @@ else
_ACEOF
if (eval "$ac_cpp conftest.$ac_ext") 2>&5 |
- $EGREP "i386_io_perm_modify" >/dev/null 2>&1; then
+ egrep "i386_io_perm_modify" >/dev/null 2>&1; then
libc_cv_mach_i386_ioports=yes
else
libc_cv_mach_i386_ioports=no
@@ -543,7 +546,7 @@ else
_ACEOF
if (eval "$ac_cpp conftest.$ac_ext") 2>&5 |
- $EGREP "i386_set_gdt" >/dev/null 2>&1; then
+ egrep "i386_set_gdt" >/dev/null 2>&1; then
libc_cv_mach_i386_gdt=yes
else
libc_cv_mach_i386_gdt=no
diff --git a/sysdeps/mach/hurd/alpha/tls.h b/sysdeps/mach/hurd/alpha/tls.h
new file mode 100644
index 0000000000..e820a013bf
--- /dev/null
+++ b/sysdeps/mach/hurd/alpha/tls.h
@@ -0,0 +1,53 @@
+/* Definition for thread-local data handling. Hurd/Alpha version.
+ Copyright (C) 2002 Free Software Foundation, Inc.
+ This file is part of the GNU C Library.
+
+ The GNU C Library is free software; you can redistribute it and/or
+ modify it under the terms of the GNU Lesser General Public
+ License as published by the Free Software Foundation; either
+ version 2.1 of the License, or (at your option) any later version.
+
+ The GNU C Library is distributed in the hope that it will be useful,
+ but WITHOUT ANY WARRANTY; without even the implied warranty of
+ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
+ Lesser General Public License for more details.
+
+ You should have received a copy of the GNU Lesser General Public
+ License along with the GNU C Library; if not, write to the Free
+ Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
+ 02111-1307 USA. */
+
+#ifndef _TLS_H
+#define _TLS_H
+
+#if defined HAVE_TLS_SUPPORT && 0
+
+/* Signal that TLS support is available. */
+# define USE_TLS 1
+
+/* Code to initially initialize the thread pointer. This might need
+ special attention since 'errno' is not yet available and if the
+ operation can cause a failure 'errno' must not be touched. */
+# define TLS_INIT_TP(descr) \
+ do \
+ { \
+ register tcbhead_t *_a0 __asm__ ("$16") = (descr); \